J-Keep In Line_牛客竞赛语法入门班数组栈、队列和stl习题 (nowcoder.com)
这道题,一眼没思路,最后发现是单调栈。
单调栈的模板
这个是单调递增栈
stack<int> st;
for (int i = 1; i <= cnt; i ++)
{
if (st.empty() || st.top() < out[i]) // 如果栈为空或者栈顶元素小于当前元素,就加入到栈中,这样写是单调递减栈
st.push(out[i]);
else // 否则,就让栈中的元素出栈,知道满足条件,然后进栈当前元素。
{
while (st.size() && st.top() > out[i])
st.pop();
st.push(out[i]);
}
}
所以这个题首先用map存一下进队的时候每个人的下标,然后出队的时候用 out 数组存一下。对out 这个数组单调栈。最后剩下的好学生人数就是单调递增的,也就是按照先进先出的顺序。用单调栈维护一段单调递增的序列,这样这一段序列的长度就是我们要求的答案
代码如下
#include <bits/stdc++.h>
#define int long long
using namespace std;
constexpr int N = 1e5 + 10;
int out[N];
int n;
void solve()
{
int idx = 0, cnt = 0;
memset(out, 0, sizeof out);
cin >> n;
map<string, int> mp;
for (int i = 1; i <= n; i ++)
{
string op, name;
cin >> op >> name;
if (op == "in")
{
mp[name] = ++idx;
}
else
{
out[++cnt] = mp[name];
}
}
stack<int> st;
for (int i = 1; i <= cnt; i ++)
{
if (st.empty() || st.top() < out[i]) // 如果栈为空或者栈顶元素小于当前元素,就加入到栈中,这样写是单调递减栈
st.push(out[i]);
else // 否则,就让栈中的元素出栈,知道满足条件,然后进栈当前元素。
{
while (st.size() && st.top() > out[i])
st.pop();
st.push(out[i]);
}
}
cout << st.size() << "\n"; // 顺序一样的,单调的就是好孩子
}
signed main()
{
ios::sync_with_stdio(false);
cin.tie();
int t = 1;
cin >> t;
while (t--)
{
solve();
}
return 0;
}